#version 300 es

precision highp float;

const lowp float hardness = 0.05;

uniform vec2 u_Center;
uniform float u_Radius;
uniform float u_Intensity;
uniform int u_Mode; // 0 - color, 1 - lighten, 2 - darken
uniform lowp vec3 u_Color;

in highp vec2 u_VertexPos;

layout(location = 0) out highp vec4 o_FragColor;

void main() {
    float d = sqrt(pow(u_VertexPos.x - u_Center.x, 2.0) + pow(u_VertexPos.y - u_Center.y, 2.0));
    float i = d / u_Radius;
    float a = i <= hardness ? 1.0 : (1.0 - (d - hardness * u_Radius) / (u_Radius - hardness * u_Radius));
    vec4 color;

    if (u_Mode == 0) {
        color = vec4(u_Color, 1.0) * pow(a * u_Intensity, 2.0);
    } else {
        d = pow(a * u_Intensity, 2.0) * 0.5;
        color = vec4(d, 0.0, 0.0, 1.0);
    }

    o_FragColor = color;
}