#version 300 es

precision highp float;

uniform float u_Time;
uniform vec2 u_Offset;
uniform float u_Speed;
uniform float u_Scale; // масштабирование градиента [0..1) - отдаление, (1..] - приближение
uniform int u_Complexity;

uniform float u_HUEOffset;
uniform float u_SatFactor;
uniform float u_LightFactor;

uniform sampler2D u_Mask;
uniform int u_UseMask;

in vec2 v_GCoord;

layout(location = 0) out vec4 o_FragColor;

vec3 nearest (vec3 col) {
    vec2 p = v_GCoord;
    float time = u_Time / u_Speed;

    //vec3 color1 = vec3(0.,0.,0.);
    //vec3 color2 = vec3(1.,1.,1.);

    vec3 color1 = vec3(0./255.,122./255.,255./255.);
    vec3 color2 = vec3(143./255.,255./255.,0./255.);
    vec3 color3 = vec3(255./255.,0./255.,0./255.);
    vec3 color4 = vec3(255./255.,194./255.,0./255.);

    vec3 vect1 = vec3(color3 - col);
    vec3 vect2 = vec3(color1 - col);

    float dist1 = length(vect1);
    float dist2 = length(vect2);

    //dist1 = 1. - dist1;
    //dist2 = 1. - dist2;

    //dist1 = dist1*dist1;
    //dist2 = dist2*dist2;

    float sum = (dist1+dist2);

    //dist1 = dist1/sum;
    //dist2 = dist2/sum;

    //dist1 = 1. - dist1;
    //dist2 = 1. - dist2;

    float dist = (dist1-dist2);

    //return col + vect2*dist2;


    col.y=col.x*col.z;


    return col + vect1*dist1*(sin(time)/2.+.5)*0.2 + vect2*dist2*(sin(time+3.14)/2.+.5)*0.2;
}

vec3 rgb2hsv(vec3 c)
{
    vec4 K = vec4(0.0, -1.0 / 3.0, 2.0 / 3.0, -1.0);
    vec4 p = mix(vec4(c.bg, K.wz), vec4(c.gb, K.xy), step(c.b, c.g));
    vec4 q = mix(vec4(p.xyw, c.r), vec4(c.r, p.yzx), step(p.x, c.r));

    float d = q.x - min(q.w, q.y);
    float e = 1.0e-10;
    return vec3(abs(q.z + (q.w - q.y) / (6.0 * d + e)), d / (q.x + e), q.x);
}

vec3 hsv2rgb(vec3 c)
{
    vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
    vec3 p = abs(fract(c.xxx + K.xyz) * 6.0 - K.www);
    return c.z * mix(K.xxx, clamp(p - K.xxx, 0.0, 1.0), c.y);
}

void main() {
    vec2 p = 2.0 + v_GCoord / u_Scale;
    vec3 col;

    p.xy += u_Offset;

    float time = u_Time / u_Speed;

    for(float j = 0.0; j < 3.0; j++)
    {
        for(float i = 1.0; i < 12.0; i++)
        {
            p.x += 0.1 / (i + j) * sin(i * 9.0 * p.y + time * 0.19 + cos((0.4335 * time / (7.11 * i)) * i - j));
            p.y += 0.1 / (i + j) * cos(i * 7.34 * p.x + time * 0.32 + sin((time * 0.7713 / (6. * i)) * i + j));
        }

        col[int(j)] = (cos(7.0*p.x*p.x) + sin(7.0*p.y*p.y)) ;
    }


    col = 0.25 * col -0.3 + sin(0.75 + normalize(col + 10.5));


    col = nearest(col);

    col = rgb2hsv(col);
    col.x = mod(col.x + u_HUEOffset, 1.0);
    col.y = col.y * u_SatFactor;
    col.z = col.z * u_LightFactor;
    col = hsv2rgb(col);

    float a = 1.0;

    if (u_UseMask == 1) {
        vec2 texCoords = vec2(v_GCoord.x + 0.5, 1.0 - (v_GCoord.y + 0.5));
        a = texture(u_Mask, texCoords).r;
    }

    o_FragColor = vec4(col, 1.0) * a;

    o_FragColor = vec4( col, 1.0);
}
