#version 300 es

in vec4 a_Position;
in vec2 a_Normal;
in vec2 a_Miter;

uniform mat4 u_ProjM;
uniform mat4 u_ModelM;
uniform mat4 u_ViewM;
uniform mat4 u_ZRotM;
uniform mat4 u_YRotM;
uniform mat4 u_XRotM;
uniform float u_Thickness;

out vec2 v_TexCoord;

float map(float value, float inMin, float inMax, float outMin, float outMax) {
    return (value - inMin) * (outMax - outMin) / (inMax - inMin) + outMin;
}

void main()
{
    float len = a_Miter.x == 0.0 && a_Miter.y == 0.0 ? 0.0 : u_Thickness /  dot(a_Miter, a_Normal);
    vec4 pos = a_Position + vec4(a_Miter * len, 0.0, 0.0);
    v_TexCoord = (pos.xy + vec2(1.0, 1.0)) / 2.0;
    gl_Position = u_ProjM * (u_ViewM * (u_XRotM * (u_YRotM * (u_ZRotM * (u_ModelM * pos)))));
}